Index: include/ndk/kdfuncs.h
===================================================================
--- include/ndk/kdfuncs.h	(revision 21808)
+++ include/ndk/kdfuncs.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -34,91 +34,37 @@
 NTAPI
 KdPollBreakIn(VOID);
 
-BOOLEAN
+NTSTATUS
 NTAPI
-KdPortInitialize(
-    PKD_PORT_INFORMATION PortInformation,
-    ULONG Unknown1,
-    ULONG Unknown2
-);
+KdRestore(IN BOOLEAN DisableDbgPorts);
 
-BOOLEAN
+NTSTATUS
 NTAPI
-KdPortInitializeEx(
-    PKD_PORT_INFORMATION PortInformation,
-    ULONG Unknown1,
-    ULONG Unknown2
-);
+KdSave(IN ULONG Unknown);
 
-BOOLEAN
+#ifdef _ARC_
+NTSTATUS
 NTAPI
-KdPortGetByte(
-    PUCHAR ByteRecieved
+KdDebuggerInitialize0(
+    IN struct _LOADER_PARAMETER_BLOCK *LoaderBlock
 );
+#endif
 
-BOOLEAN
+//
+// Debugger API
+//
+NTSTATUS
 NTAPI
-KdPortGetByteEx(
-    PKD_PORT_INFORMATION PortInformation,
-    PUCHAR ByteRecieved
+KdSystemDebugControl(
+    SYSDBG_COMMAND Command,
+    PVOID InputBuffer,
+    ULONG InputBufferLength,
+    PVOID OutputBuffer,
+    ULONG OutputBufferLength,
+    PULONG ReturnLength,
+    KPROCESSOR_MODE PreviousMode
 );
 
-BOOLEAN
-NTAPI
-KdPortPollByte(
-    PUCHAR ByteRecieved
-);
-
-BOOLEAN
-NTAPI
-KdPortPollByteEx(
-    PKD_PORT_INFORMATION PortInformation,
-    PUCHAR ByteRecieved
-);
-
-VOID
-NTAPI
-KdPortPutByte(
-    UCHAR ByteToSend
-);
-
-VOID
-NTAPI
-KdPortPutByteEx(
-    PKD_PORT_INFORMATION PortInformation,
-    UCHAR ByteToSend
-);
-
-VOID
-NTAPI
-KdPortRestore(VOID);
-
-VOID
-NTAPI
-KdPortSave (VOID);
-
-VOID
-NTAPI
-KdRestore(VOID);
-
-VOID
-NTAPI
-KdSave (VOID);
-
-BOOLEAN
-NTAPI
-KdPortDisableInterrupts(VOID);
-
-BOOLEAN
-NTAPI
-KdPortEnableInterrupts(VOID);
-
-BOOLEAN
-NTAPI
-KdDebuggerInitialize0(
-    IN PLOADER_PARAMETER_BLOCK LoaderBlock
-);
-
 #endif
 
 //
@@ -145,7 +91,7 @@
 NTSTATUS
 NTAPI
 NtSystemDebugControl(
-    DEBUG_CONTROL_CODE ControlCode,
+    SYSDBG_COMMAND ControlCode,
     PVOID InputBuffer,
     ULONG InputBufferLength,
     PVOID OutputBuffer,
@@ -174,7 +120,7 @@
 NTSTATUS
 NTAPI
 ZwSystemDebugControl(
-    DEBUG_CONTROL_CODE ControlCode,
+    SYSDBG_COMMAND ControlCode,
     PVOID InputBuffer,
     ULONG InputBufferLength,
     PVOID OutputBuffer,
Index: include/ndk/mmtypes.h
===================================================================
--- include/ndk/mmtypes.h	(revision 21808)
+++ include/ndk/mmtypes.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -200,21 +200,242 @@
 #ifndef NTOS_MODE_USER
 
 //
-// FIXME: REACTOS SPECIFIC HACK IN EPROCESS
+// PTE Structures
 //
-#ifdef _REACTOS_
-typedef struct _MADDRESS_SPACE
+typedef struct _MMPTE
 {
-    struct _MEMORY_AREA *MemoryAreaRoot;
-    FAST_MUTEX Lock;
-    PVOID LowestAddress;
-    struct _EPROCESS* Process;
-    PUSHORT PageTableRefCountTable;
-    ULONG PageTableRefCountTableSize;
-} MADDRESS_SPACE, *PMADDRESS_SPACE;
-#endif
+    union
+    {
+        ULONG Long;
+        HARDWARE_PTE Flush;
+        MMPTE_HARDWARE Hard;
+        MMPTE_PROTOTYPE Proto;
+        MMPTE_SOFTWARE Soft;
+        MMPTE_TRANSITION Trans;
+        MMPTE_SUBSECTION Subsect;
+        MMPTE_LIST List;
+    };
+} MMPTE, *PMMPTE;
 
 //
+// Section Information structure
+//
+typedef struct _MI_EXTRA_IMAGE_INFORMATION
+{
+    ULONG SizeOfHeaders;
+} MI_EXTRA_IMAGE_INFORMATION, *PMI_EXTRA_IMAGE_INFORMATION;
+
+typedef struct _MI_SECTION_IMAGE_INFORMATION
+{
+    SECTION_IMAGE_INFORMATION ExportedImageInformation;
+    MI_EXTRA_IMAGE_INFORMATION InternalImageInformation;
+} MI_SECTION_IMAGE_INFORMATION, *PMI_SECTION_IMAGE_INFORMATION;
+
+//
+// Section Extension Information
+//
+typedef struct _MMEXTEND_INFO
+{
+    ULONGLONG CommittedSize;
+    ULONG ReferenceCount;
+} MMEXTEND_INFO, *PMMEXTEND_INFO;
+
+//
+// Segment and Segment Flags
+//
+typedef struct _SEGMENT_FLAGS
+{
+    ULONG TotalNumberOfPtes4132:10;
+    ULONG ExtraSharedWowSubsections:1;
+    ULONG LargePages:1;
+    ULONG Spare:20;
+} SEGMENT_FLAGS, *PSEGMENT_FLAGS;
+
+typedef struct _SEGMENT
+{
+    struct _CONTROL_AREA *ControlArea;
+    ULONG TotalNumberOfPtes;
+    ULONG NonExtendedPtes;
+    ULONG Spare0;
+    ULONGLONG SizeOfSegment;
+    MMPTE SegmentPteTemplate;
+    ULONG NumberOfCommittedPages;
+    PMMEXTEND_INFO ExtendInfo;
+    SEGMENT_FLAGS SegmentFlags;
+    PVOID BaseAddress;
+    union
+    {
+        ULONG ImageCommitment;
+        PEPROCESS CreatingProcess;
+    } u1;
+    union
+    {
+        PMI_SECTION_IMAGE_INFORMATION ImageInformation;
+        PVOID FirstMappedVa;
+    } u2;
+    PMMPTE PrototypePte;
+    MMPTE ThePtes[1];
+} SEGMENT, *PSEGMENT;
+
+//
+// Event Counter Structure
+//
+typedef struct _EVENT_COUNTER
+{
+    ULONG RefCount;
+    KEVENT Event;
+    LIST_ENTRY ListEntry;
+} EVENT_COUNTER, *PEVENT_COUNTER;
+
+//
+// Flags
+//
+typedef struct _MMSECTION_FLAGS
+{
+    ULONG BeingDeleted:1;
+    ULONG BeingCreated:1;
+    ULONG BeingPurged:1;
+    ULONG NoModifiedWriting:1;
+    ULONG FailAllIo:1;
+    ULONG Image:1;
+    ULONG Based:1;
+    ULONG File:1;
+    ULONG Networked:1;
+    ULONG NoCache:1;
+    ULONG PhysicalMemory:1;
+    ULONG CopyOnWrite:1;
+    ULONG Reserve:1;
+    ULONG Commit:1;
+    ULONG FloppyMedia:1;
+    ULONG WasPurged:1;
+    ULONG UserReference:1;
+    ULONG GlobalMemory:1;
+    ULONG DeleteOnClose:1;
+    ULONG FilePointerNull:1;
+    ULONG DebugSymbolsLoaded:1;
+    ULONG SetMappedFileIoComplete:1;
+    ULONG CollidedFlush:1;
+    ULONG NoChange:1;
+    ULONG filler0:1;
+    ULONG ImageMappedInSystemSpace:1;
+    ULONG UserWritable:1;
+    ULONG Accessed:1;
+    ULONG GlobalOnlyPerSession:1;
+    ULONG Rom:1;
+    ULONG WriteCombined:1;
+    ULONG filler:1;
+} MMSECTION_FLAGS, *PMMSECTION_FLAGS;
+
+typedef struct _MMSUBSECTION_FLAGS
+{
+    ULONG ReadOnly:1;
+    ULONG ReadWrite:1;
+    ULONG SubsectionStatic:1;
+    ULONG GlobalMemory:1;
+    ULONG Protection:5;
+    ULONG Spare:1;
+    ULONG StartingSector4132:10;
+    ULONG SectorEndOffset:12;
+} MMSUBSECTION_FLAGS, *PMMSUBSECTION_FLAGS;
+
+//
+// Control Area Structures
+//
+typedef struct _CONTROL_AREA
+{
+    PSEGMENT Segment;
+    LIST_ENTRY DereferenceList;
+    ULONG NumberOfSectionReferences;
+    ULONG NumberOfPfnReferences;
+    ULONG NumberOfMappedViews;
+    ULONG NumberOfSystemCacheViews;
+    ULONG NumberOfUserReferences;
+    union
+    {
+        ULONG LongFlags;
+        MMSECTION_FLAGS Flags;
+    } u;
+    PFILE_OBJECT FilePointer;
+    PEVENT_COUNTER WaitingForDeletion;
+    USHORT ModifiedWriteCount;
+    USHORT FlushInProgressCount;
+    ULONG WritableUserReferences;
+    ULONG QuadwordPad;
+} CONTROL_AREA, *PCONTROL_AREA;
+
+typedef struct _LARGE_CONTROL_AREA
+{
+    PSEGMENT Segment;
+    LIST_ENTRY DereferenceList;
+    ULONG NumberOfSectionReferences;
+    ULONG NumberOfPfnReferences;
+    ULONG NumberOfMappedViews;
+    ULONG NumberOfSystemCacheViews;
+    ULONG NumberOfUserReferences;
+    union
+    {
+        ULONG LongFlags;
+        MMSECTION_FLAGS Flags;
+    } u;
+    PFILE_OBJECT FilePointer;
+    PEVENT_COUNTER WaitingForDeletion;
+    USHORT ModifiedWriteCount;
+    USHORT FlushInProgressCount;
+    ULONG WritableUserReferences;
+    ULONG QuadwordPad;
+    ULONG StartingFrame;
+    LIST_ENTRY UserGlobalList;
+    ULONG SessionId;
+} LARGE_CONTROL_AREA, *PLARGE_CONTROL_AREA;
+
+//
+// Subsection
+//
+typedef struct _SUBSECTION
+{
+    PCONTROL_AREA ControlArea;
+    union
+    {
+        ULONG LongFlags;
+        MMSUBSECTION_FLAGS SubsectionFlags;
+    } u;
+    ULONG StartingSector;
+    PMMPTE SubsectionBase;
+    ULONG UnusedPtes;
+    ULONG PtesInSubsection;
+    struct _SUBSECTION *NextSubSection;
+} SUBSECTION, *PSUBSECTION;
+
+//
+// Segment Object
+//
+typedef struct _SEGMENT_OBJECT
+{
+    PVOID BaseAddress;
+    ULONG TotalNumberOfPtes;
+    LARGE_INTEGER SizeOfSegment;
+    ULONG NonExtendedPtes;
+    ULONG ImageCommitment;
+    PCONTROL_AREA ControlArea;
+    PSUBSECTION Subsection;
+    PLARGE_CONTROL_AREA LargeControlArea;
+    PMMSECTION_FLAGS MmSectionFlags;
+    PMMSUBSECTION_FLAGS MmSubSectionFlags;
+} SEGMENT_OBJECT, *PSEGMENT_OBJECT;
+
+//
+// Section Object
+//
+typedef struct _SECTION_OBJECT
+{
+    PVOID StartingVa;
+    PVOID EndingVa;
+    PVOID LeftChild;
+    PVOID RightChild;
+    PSEGMENT_OBJECT Segment;
+} SECTION_OBJECT, *PSECTION_OBJECT;
+
+//
 // Generic Address Range Structure
 //
 typedef struct _ADDRESS_RANGE
Index: include/ndk/obfuncs.h
===================================================================
--- include/ndk/obfuncs.h	(revision 21808)
+++ include/ndk/obfuncs.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
Index: include/ndk/rtlfuncs.h
===================================================================
--- include/ndk/rtlfuncs.h	(revision 21808)
+++ include/ndk/rtlfuncs.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -24,9 +24,15 @@
 //
 #include <umtypes.h>
 #include <ntnls.h>
+#include <rtltypes.h>
 #include <extypes.h>
-#include <rtltypes.h>
+#include "in6addr.h"
+#include "inaddr.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
 #ifdef NTOS_MODE_USER
 
 //
@@ -109,7 +115,7 @@
 FORCEINLINE
 BOOLEAN
 RemoveEntryList(
-    IN PLIST_ENTRY  Entry)
+    IN PLIST_ENTRY Entry)
 {
     PLIST_ENTRY OldFlink;
     PLIST_ENTRY OldBlink;
@@ -124,7 +130,7 @@
 FORCEINLINE
 PLIST_ENTRY
 RemoveHeadList(
-    IN PLIST_ENTRY  ListHead)
+    IN PLIST_ENTRY ListHead)
 {
     PLIST_ENTRY Flink;
     PLIST_ENTRY Entry;
@@ -139,7 +145,7 @@
 FORCEINLINE
 PLIST_ENTRY
 RemoveTailList(
-    IN PLIST_ENTRY  ListHead)
+    IN PLIST_ENTRY ListHead)
 {
     PLIST_ENTRY Blink;
     PLIST_ENTRY Entry;
@@ -152,12 +158,61 @@
 }
 
 //
+// Unicode string macros
+//
+FORCEINLINE
+VOID
+RtlInitEmptyUnicodeString(OUT PUNICODE_STRING UnicodeString,
+                          IN PWSTR Buffer,
+                          IN USHORT BufferSize)
+{
+    UnicodeString->Length = 0;
+    UnicodeString->MaximumLength = BufferSize;
+    UnicodeString->Buffer = Buffer;
+}
+
+//
 // LUID Macros
 //
 #define RtlEqualLuid(L1, L2) (((L1)->HighPart == (L2)->HighPart) && \
                               ((L1)->LowPart  == (L2)->LowPart))
+FORCEINLINE
+LUID
+NTAPI_INLINE
+RtlConvertUlongToLuid(ULONG Ulong)
+{
+    LUID TempLuid;
 
+    TempLuid.LowPart = Ulong;
+    TempLuid.HighPart = 0;
+    return TempLuid;
+}
+
 //
+// ASSERT Macros
+//
+#ifndef ASSERT
+#if DBG
+
+#define ASSERT( exp ) \
+    ((!(exp)) ? \
+        (RtlAssert( #exp, __FILE__, __LINE__, NULL ),FALSE) : \
+        TRUE)
+
+#define ASSERTMSG( msg, exp ) \
+    ((!(exp)) ? \
+        (RtlAssert( #exp, __FILE__, __LINE__, msg ),FALSE) : \
+        TRUE)
+
+#else
+
+#define ASSERT( exp )         ((void) 0)
+#define ASSERTMSG( msg, exp ) ((void) 0)
+
+#endif
+#endif
+
+//
 // RTL Splay Tree Functions
 //
 NTSYSAPI
@@ -268,17 +323,16 @@
 );
 
 NTSYSAPI
-VOID
+PVOID
 NTAPI
-RtlCaptureContext(OUT PCONTEXT ContextRecord);
+RtlSetUnhandledExceptionFilter(
+    IN PVOID TopLevelExceptionFilter
+);
 
 NTSYSAPI
-ULONG
+VOID
 NTAPI
-RtlComputeCrc32(
-    IN ULONG Initial,
-    IN PUCHAR Data,
-    IN ULONG Length);
+RtlCaptureContext(OUT PCONTEXT ContextRecord);
 
 NTSYSAPI
 PVOID
@@ -291,6 +345,16 @@
 RtlDecodePointer(IN PVOID Pointer);
 
 NTSYSAPI
+PVOID
+NTAPI
+RtlEncodeSystemPointer(IN PVOID Pointer);
+
+NTSYSAPI
+PVOID
+NTAPI
+RtlDecodeSystemPointer(IN PVOID Pointer);
+
+NTSYSAPI
 BOOLEAN
 NTAPI
 RtlDispatchException(
@@ -329,6 +393,14 @@
 );
 
 //
+// Tracing Functions
+//
+NTSYSAPI
+USHORT
+NTAPI
+RtlLogStackBackTrace(VOID);
+
+//
 // Heap Functions
 //
 NTSYSAPI
@@ -355,6 +427,15 @@
 NTSYSAPI
 ULONG
 NTAPI
+RtlCreateTagHeap(
+    IN HANDLE HeapHandle,
+    IN ULONG Flags,
+    IN PWSTR TagName,
+    IN PWSTR TagSubName
+);
+
+ULONG
+NTAPI
 RtlCompactHeap(
     HANDLE heap,
     ULONG flags
@@ -515,6 +596,16 @@
 NTSYSAPI
 NTSTATUS
 NTAPI
+RtlAcquirePrivilege(
+    IN PULONG Privilege,
+    IN ULONG NumPriv,
+    IN ULONG Flags,
+    OUT PVOID *ReturnedState
+);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
 RtlAdjustPrivilege(
     IN ULONG Privilege,
     IN BOOLEAN NewValue,
@@ -787,6 +878,13 @@
 );
 
 NTSYSAPI
+VOID
+NTAPI
+RtlReleasePrivilege(
+    IN PVOID ReturnedState
+);
+
+NTSYSAPI
 NTSTATUS
 NTAPI
 RtlSelfRelativeToAbsoluteSD(
@@ -1050,14 +1148,17 @@
 
 #else
 
+NTSYSAPI
 USHORT
 FASTCALL
 RtlUshortByteSwap(IN USHORT Source);
 
+NTSYSAPI
 ULONG
 FASTCALL
 RtlUlongByteSwap(IN ULONG Source);
 
+NTSYSAPI
 ULONGLONG
 FASTCALL
 RtlUlonglongByteSwap(IN ULONGLONG Source);
@@ -1351,6 +1452,16 @@
 );
 
 NTSYSAPI
+NTSTATUS
+NTAPI
+RtlFindCharInUnicodeString(
+    IN ULONG Flags,
+    IN PUNICODE_STRING SearchString,
+    IN PCUNICODE_STRING MatchString,
+    OUT PUSHORT Position
+);
+
+NTSYSAPI
 VOID
 NTAPI
 RtlFreeUnicodeString(IN PUNICODE_STRING UnicodeString);
@@ -1369,10 +1480,19 @@
 VOID
 NTAPI
 RtlInitUnicodeString(
-  IN OUT PUNICODE_STRING DestinationString,
-  IN PCWSTR SourceString);
+    IN OUT PUNICODE_STRING DestinationString,
+    IN PCWSTR SourceString
+);
 
 NTSYSAPI
+NTSTATUS
+NTAPI
+RtlInitUnicodeStringEx(
+    OUT PUNICODE_STRING DestinationString,
+    IN PCWSTR SourceString OPTIONAL
+);
+
+NTSYSAPI
 ULONG
 NTAPI
 RtlIsTextUnicode(
@@ -1417,6 +1537,14 @@
     PULONG Value
 );
 
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlValidateUnicodeString(
+    IN ULONG Flags,
+    IN PCUNICODE_STRING String
+);
+
 //
 // Ansi String Functions
 //
@@ -1653,30 +1781,60 @@
 );
 
 NTSYSAPI
+NTSTATUS
+NTAPI
+RtlComputePrivatizedDllName_U(
+    IN PUNICODE_STRING DllName,
+    OUT PUNICODE_STRING RealName,
+    OUT PUNICODE_STRING LocalName
+);
+
+NTSYSAPI
 VOID
 NTAPI
-RtlDestroyEnvironment(PWSTR Environment);
+RtlDestroyEnvironment(
+    IN PWSTR Environment
+);
 
 NTSYSAPI
 BOOLEAN
 NTAPI
-RtlDoesFileExists_U(PWSTR FileName);
+RtlDoesFileExists_U(
+    IN PCWSTR FileName
+);
 
 NTSYSAPI
+BOOLEAN
+NTAPI
+RtlDoesFileExists_UstrEx(
+    IN PCUNICODE_STRING FileName,
+    IN BOOLEAN SucceedIfBusy
+);
+
+NTSYSAPI
 ULONG
 NTAPI
-RtlDetermineDosPathNameType_U(PCWSTR Path);
+RtlDetermineDosPathNameType_U(
+    IN PCWSTR Path
+);
 
 NTSYSAPI
 ULONG
 NTAPI
+RtlDetermineDosPathNameType_Ustr(
+    IN PCUNICODE_STRING Path
+);
+
+NTSYSAPI
+ULONG
+NTAPI
 RtlDosSearchPath_U(
-    WCHAR *sp,
-    WCHAR *name,
-    WCHAR *ext,
-    ULONG buf_sz,
-    WCHAR *buffer,
-    WCHAR **shortname
+    IN PCWSTR Path,
+    IN PCWSTR FileName,
+    IN PCWSTR Extension,
+    IN ULONG BufferSize,
+    OUT PWSTR Buffer,
+    OUT PWSTR *PartName
 );
 
 NTSYSAPI
@@ -1711,13 +1869,40 @@
 ULONG
 NTAPI
 RtlGetFullPathName_U(
-    const WCHAR *dosname,
-    ULONG size,
-    WCHAR *buf,
-    WCHAR **shortname
+    IN PCWSTR FileName,
+    IN ULONG Size,
+    IN PWSTR Buffer,
+    OUT PWSTR *ShortName
 );
 
 NTSYSAPI
+ULONG
+NTAPI
+RtlGetFullPathName_Ustr(
+    IN PUNICODE_STRING FileName,
+    IN ULONG Size,
+    IN PWSTR Buffer,
+    OUT PWSTR *ShortName,
+    OUT PBOOLEAN InvalidName,
+    OUT RTL_PATH_TYPE *PathType
+);
+
+NTSYSAPI
+ULONG
+NTAPI
+RtlIsDosDeviceName_U(
+    IN PWSTR Name
+);
+
+NTSYSAPI
+ULONG
+NTAPI
+RtlIsDosDeviceName_Ustr(
+    IN PUNICODE_STRING Name
+);
+
+
+NTSYSAPI
 BOOLEAN
 NTAPI
 RtlIsNameLegalDOS8Dot3(
@@ -1738,7 +1923,9 @@
 NTSYSAPI
 NTSTATUS
 NTAPI
-RtlSetCurrentDirectory_U(PUNICODE_STRING name);
+RtlSetCurrentDirectory_U(
+    IN PUNICODE_STRING name
+);
 
 NTSYSAPI
 NTSTATUS
@@ -1789,6 +1976,13 @@
 );
 
 NTSYSAPI
+BOOLEAN
+NTAPI
+RtlTryEnterCriticalSection(
+    IN PRTL_CRITICAL_SECTION CriticalSection
+);
+
+NTSYSAPI
 VOID
 NTAPI
 RtlpUnWaitCriticalSection(
@@ -1902,7 +2096,7 @@
 // Debug Info Functions
 //
 NTSYSAPI
-PRTL_DEBUG_BUFFER
+PRTL_DEBUG_INFORMATION
 NTAPI
 RtlCreateQueryDebugBuffer(
     IN ULONG Size,
@@ -1912,7 +2106,7 @@
 NTSYSAPI
 NTSTATUS
 NTAPI
-RtlDestroyQueryDebugBuffer(IN PRTL_DEBUG_BUFFER DebugBuffer);
+RtlDestroyQueryDebugBuffer(IN PRTL_DEBUG_INFORMATION DebugBuffer);
 
 NTSYSAPI
 NTSTATUS
@@ -1920,7 +2114,7 @@
 RtlQueryProcessDebugInformation(
     IN ULONG ProcessId,
     IN ULONG DebugInfoClassMask,
-    IN OUT PRTL_DEBUG_BUFFER DebugBuffer
+    IN OUT PRTL_DEBUG_INFORMATION DebugBuffer
 );
 
 //
@@ -1983,7 +2177,15 @@
 NTSYSAPI
 VOID
 NTAPI
-RtlSetBits (
+RtlSetBit(
+    PRTL_BITMAP BitMapHeader,
+    ULONG BitNumber
+);
+
+NTSYSAPI
+VOID
+NTAPI
+RtlSetBits(
     IN PRTL_BITMAP BitMapHeader,
     IN ULONG StartingIndex,
     IN ULONG NumberToSet
@@ -2043,6 +2245,26 @@
 RtlDeleteTimerQueue(HANDLE TimerQueue);
 
 //
+// SList functions
+//
+PSLIST_ENTRY
+FASTCALL
+InterlockedPushListSList(
+    IN PSLIST_HEADER ListHead,
+    IN PSLIST_ENTRY List,
+    IN PSLIST_ENTRY ListEnd,
+    IN ULONG Count
+);
+
+//
+// Range List functions
+//
+NTSYSAPI
+VOID
+NTAPI
+RtlFreeRangeList(IN PRTL_RANGE_LIST RangeList);
+
+//
 // Debug Functions
 //
 ULONG
@@ -2052,6 +2274,24 @@
     IN ...
 );
 
+NTSYSAPI
+ULONG
+__cdecl
+DbgPrintEx(
+    IN ULONG ComponentId,
+    IN ULONG Level,
+    IN PCH Format,
+    IN ...
+);
+
+ULONG
+NTAPI
+DbgPrompt(
+    IN PCH PromptString,
+    OUT PCH OutputString,
+    IN ULONG OutputSize
+);
+
 VOID
 NTAPI
 DbgBreakPoint(VOID);
@@ -2129,9 +2369,9 @@
 PVOID
 NTAPI
 RtlImageDirectoryEntryToData(
-    PVOID  BaseAddress,
-    BOOLEAN bFlag,
-    ULONG Directory,
+    PVOID BaseAddress,
+    BOOLEAN MappedAsImage,
+    USHORT Directory,
     PULONG Size
 );
 
@@ -2151,6 +2391,16 @@
 RtlImageNtHeader(IN PVOID BaseAddress);
 
 NTSYSAPI
+NTSTATUS
+NTAPI
+RtlImageNtHeaderEx(
+    IN ULONG Flags,
+    IN PVOID BaseAddress,
+    IN ULONGLONG Size,
+    IN PIMAGE_NT_HEADERS *NtHeader
+);
+
+NTSYSAPI
 PIMAGE_SECTION_HEADER
 NTAPI
 RtlImageRvaToSection(
@@ -2160,6 +2410,73 @@
 );
 
 //
+// Activation Context Functions
+//
+#ifdef NTOS_MODE_USER
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlActivateActivationContextUnsafeFast(
+    IN PRTL_CALLER_ALLOCATED_ACTIVATION_CONTEXT_STACK_FRAME_EXTENDED Frame,
+    IN PVOID Context
+);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlAllocateActivationContextStack(
+    IN PVOID *Context
+);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlGetActiveActivationContext(
+    IN PVOID *Context
+);
+
+NTSYSAPI
+VOID
+NTAPI
+RtlReleaseActivationContext(
+    IN PVOID *Context
+);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlDeactivateActivationContextUnsafeFast(
+    IN PRTL_CALLER_ALLOCATED_ACTIVATION_CONTEXT_STACK_FRAME_EXTENDED Frame
+);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlDosApplyFileIsolationRedirection_Ustr(
+    IN BOOLEAN Unknown,
+    IN PUNICODE_STRING OriginalName,
+    IN PUNICODE_STRING Extension,
+    IN OUT PUNICODE_STRING RedirectedName,
+    IN OUT PUNICODE_STRING RedirectedName2,
+    IN OUT PUNICODE_STRING *OriginalName2,
+    IN PVOID Unknown1,
+    IN PVOID Unknown2,
+    IN PVOID Unknown3
+);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlFindActivationContextSectionString(
+    IN PVOID Unknown0,
+    IN PVOID Unknown1,
+    IN ULONG SectionType,
+    IN PUNICODE_STRING SectionName,
+    IN PVOID Unknown2
+);
+#endif
+
+//
 // Registry Functions
 //
 NTSYSAPI
@@ -2311,8 +2628,19 @@
 NTSYSAPI
 ULONG
 NTAPI
-RtlUniform(PULONG Seed);
+RtlUniform(
+    IN PULONG Seed
+);
 
+NTSYSAPI
+ULONG
+NTAPI
+RtlComputeCrc32(
+    IN UINT PartialCrc,
+    IN PUCHAR Buffer,
+    IN ULONG Length
+);
+
 //
 // Network Functions
 //
@@ -2320,36 +2648,36 @@
 NTSTATUS
 NTAPI
 RtlIpv4StringToAddressW(
-    IN LPWSTR IpString,
-    IN ULONG Base,
-    OUT PULONG PtrToIpAddr,
-    OUT PULONG IpAddr
+    IN PWCHAR String,
+    IN UCHAR Strict,
+    OUT PWCHAR Terminator,
+    OUT struct in_addr *Addr
 );
 
 NTSYSAPI
 NTSTATUS
 NTAPI
 RtlIpv6StringToAddressA(
-    IN LPSTR Name,
-    OUT PULONG Unknown,
-    OUT PVOID IpAddr
+    IN PCHAR Name,
+    OUT PCHAR *Terminator,
+    OUT struct in6_addr *Addr
 );
 
 NTSYSAPI
 NTSTATUS
 NTAPI
 RtlIpv6StringToAddressW(
-    IN LPWSTR Name,
-    OUT PULONG Unknown,
-    OUT PVOID IpAddr
+    IN PWCHAR Name,
+    OUT PCHAR *Terminator,
+    OUT struct in6_addr *Addr
 );
 
 NTSYSAPI
 NTSTATUS
 NTAPI
 RtlIpv6StringToAddressExA(
-    IN LPSTR AddressName,
-    IN PVOID Address,
+    IN PCHAR AddressString,
+    IN struct in6_addr *Address,
     IN PULONG ScopeId,
     IN PUSHORT Port
 );
@@ -2358,8 +2686,8 @@
 NTSTATUS
 NTAPI
 RtlIpv6StringToAddressExW(
-    IN LPWSTR AddressName,
-    IN PVOID Address,
+    IN PWCHAR AddressName,
+    IN struct in6_addr *Address,
     IN PULONG ScopeId,
     IN PUSHORT Port
 );
@@ -2368,6 +2696,7 @@
 //
 // Time Functions
 //
+struct _RTL_TIME_ZONE_INFORMATION;
 NTSYSAPI
 NTSTATUS
 NTAPI
@@ -2402,6 +2731,14 @@
     PTIME_FIELDS TimeFields
 );
 
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlSystemTimeToLocalTime(
+    IN PLARGE_INTEGER SystemTime,
+    OUT PLARGE_INTEGER LocalTime
+);
+
 //
 // Version Functions
 //
@@ -2424,4 +2761,8 @@
 NTAPI
 RtlGetNtProductType(OUT PNT_PRODUCT_TYPE ProductType);
 
+#ifdef __cplusplus
+}
 #endif
+
+#endif
Index: include/ndk/potypes.h
===================================================================
--- include/ndk/potypes.h	(revision 21808)
+++ include/ndk/potypes.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
Index: include/ndk/ldrtypes.h
===================================================================
--- include/ndk/ldrtypes.h	(revision 21808)
+++ include/ndk/ldrtypes.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -27,31 +27,47 @@
 //
 // Resource Type Levels
 //
-#define RESOURCE_TYPE_LEVEL             0
-#define RESOURCE_NAME_LEVEL             1
-#define RESOURCE_LANGUAGE_LEVEL         2
-#define RESOURCE_DATA_LEVEL             3
+#define RESOURCE_TYPE_LEVEL                     0
+#define RESOURCE_NAME_LEVEL                     1
+#define RESOURCE_LANGUAGE_LEVEL                 2
+#define RESOURCE_DATA_LEVEL                     3
 
 //
 // Loader Data Table Entry Flags
 //
-#define LDRP_STATIC_LINK                0x00000002
-#define LDRP_IMAGE_DLL                  0x00000004
-#define LDRP_LOAD_IN_PROGRESS           0x00001000
-#define LDRP_UNLOAD_IN_PROGRESS         0x00002000
-#define LDRP_ENTRY_PROCESSED            0x00004000
-#define LDRP_ENTRY_INSERTED             0x00008000
-#define LDRP_CURRENT_LOAD               0x00010000
-#define LDRP_FAILED_BUILTIN_LOAD        0x00020000
-#define LDRP_DONT_CALL_FOR_THREADS      0x00040000
-#define LDRP_PROCESS_ATTACH_CALLED      0x00080000
-#define LDRP_DEBUG_SYMBOLS_LOADED       0x00100000
-#define LDRP_IMAGE_NOT_AT_BASE          0x00200000
-#define LDRP_COR_IMAGE                  0x00400000
-#define LDR_COR_OWNS_UNMAP              0x00800000
-#define LDRP_REDIRECTED                 0x10000000
+#define LDRP_STATIC_LINK                        0x00000002
+#define LDRP_IMAGE_DLL                          0x00000004
+#define LDRP_LOAD_IN_PROGRESS                   0x00001000
+#define LDRP_UNLOAD_IN_PROGRESS                 0x00002000
+#define LDRP_ENTRY_PROCESSED                    0x00004000
+#define LDRP_ENTRY_INSERTED                     0x00008000
+#define LDRP_CURRENT_LOAD                       0x00010000
+#define LDRP_FAILED_BUILTIN_LOAD                0x00020000
+#define LDRP_DONT_CALL_FOR_THREADS              0x00040000
+#define LDRP_PROCESS_ATTACH_CALLED              0x00080000
+#define LDRP_DEBUG_SYMBOLS_LOADED               0x00100000
+#define LDRP_IMAGE_NOT_AT_BASE                  0x00200000
+#define LDRP_COR_IMAGE                          0x00400000
+#define LDR_COR_OWNS_UNMAP                      0x00800000
+#define LDRP_REDIRECTED                         0x10000000
 
 //
+// Dll Characteristics for LdrLoadDll
+//
+#define LDR_IGNORE_CODE_AUTHZ_LEVEL             0x00001000
+
+//
+// LdrAddRef Flags
+//
+#define LDR_PIN_MODULE                          0x00000001
+
+//
+// LdrLockLoaderLock Flags
+//
+#define LDR_LOCK_LOADER_LOCK_FLAG_RAISE_STATUS  0x00000001
+#define LDR_LOCK_LOADER_LOCK_FLAG_TRY_ONLY      0x00000002
+
+//
 // Loader Data stored in the PEB
 //
 typedef struct _PEB_LDR_DATA
@@ -70,7 +86,7 @@
 //
 typedef struct _LDR_DATA_TABLE_ENTRY
 {
-    LIST_ENTRY InLoadOrderModuleList;
+    LIST_ENTRY InLoadOrderLinks;
     LIST_ENTRY InMemoryOrderModuleList;
     LIST_ENTRY InInitializationOrderModuleList;
     PVOID DllBase;
@@ -107,8 +123,45 @@
 } LDR_RESOURCE_INFO, *PLDR_RESOURCE_INFO;
 
 //
-// LdrAddRef Flags
+// DLL Notifications
 //
-#define LDR_PIN_MODULE                  0x00000001
+typedef struct _LDR_DLL_LOADED_NOTIFICATION_DATA
+{
+    ULONG Flags;
+    PUNICODE_STRING FullDllName;
+    PUNICODE_STRING BaseDllName;
+    PVOID DllBase;
+    ULONG SizeOfImage;
+} LDR_DLL_LOADED_NOTIFICATION_DATA, *PLDR_DLL_LOADED_NOTIFICATION_DATA;
 
+typedef VOID
+(*PLDR_DLL_LOADED_NOTIFICATION_CALLBACK)(
+    IN BOOLEAN Type,
+    IN struct _LDR_DLL_LOADED_NOTIFICATION_DATA *Data
+);
+
+typedef struct _LDR_DLL_LOADED_NOTIFICATION_ENTRY
+{
+    LIST_ENTRY NotificationListEntry;
+    PLDR_DLL_LOADED_NOTIFICATION_CALLBACK Callback;
+} LDR_DLL_LOADED_NOTIFICATION_ENTRY, *PLDR_DLL_LOADED_NOTIFICATION_ENTRY;
+
+//
+// Alternate Resources Support
+//
+typedef struct _ALT_RESOURCE_MODULE
+{
+    LANGID LangId;
+    PVOID ModuleBase;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    PVOID ModuleManifest;
 #endif
+    PVOID AlternateModule;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    HANDLE AlternateFileHandle;
+    ULONG ModuleCheckSum;
+    ULONG ErrorCode;
+#endif
+} ALT_RESOURCE_MODULE, *PALT_RESOURCE_MODULE;
+
+#endif
